<?php
/***************************************************************************
 * $Id: mysql.class.php 59 2008-07-06 17:45:54Z Nico $
 * Part of Parsimony Import
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if  ( !class_exists ( 'MySQL_class' ) )
 {
	class MySQL_class
	 {
	 	var $countQuerys = 0;
	 	var $row = array();
	 	var $echoQuerys = false;
	 	var $connected = false;
	 	var $debugOnly = false;
	 	var $dbConnectionID;
	 	var $lastQuery;
	 	var $error = false;
	 	
	 	var $host, $user, $pass, $db, $debug;
	 	
	 	function MySQL_class ($host, $user, $pass, $db, $debug = false)
	 	 {
	 	 	$this->host = $host;
	 	 	$this->user = $user;
	 	 	$this->pass = $pass;
	 	 	$this->db = $db;
	 	 	$this->debug = $debug;
	 	 	$this->sql_connect($host, $user, $pass, $db, $debug);
	 	 }
	 	
	 	function sql_connect( $host, $user, $pass, $db, $debug = false )
	 	 {
	 	 	$this->debugOnly($debug);
	 	 	if ( !$this->debugOnly ) {
		 	 	if ( !$this->connected )
		 	 	 {
			 	 	$this->dbConnectionID = @mysql_connect( $host, $user, $pass );
			 	 	if (!$this->dbConnectionID)
			 	 	 {
						$this->error = mysql_error();
						return false;
			 	 	 }
			 	 	else
			 	 	 {
			 	 		$this->connected = true;
			 	 	 }
			 	 }
		 	 	if (!@mysql_select_db($db, $this->dbConnectionID))
		 	 	 {
						$this->error = mysql_error();
						return false;
		 	 	 }
	 	 	}
	  	 }
	  	 
	  	function sql_close ( )
	  	 {
	 		if($this->lastQuery)
			{
				@mysql_free_result($this->lastQuery);
			}
	  	 	mysql_close ( $this->dbConnectionID );
	  	 }
	 	 	
	 	
	 	function sql_query( $query )
	 	 {
 	 	 	$this->error = 'none';
 	 	 	unset($this->lastQuery);
 	 	 	@set_time_limit ( 20 );
 	 	 	++$this->countQuerys;
 	 	 	$start = time();
 	 	 	$this->error = false;
	 	 	if ( !$this->debugOnly )
	 	 	 {
		 	 	$return = mysql_query ( $query, $this->dbConnectionID  );
	 	 	 	if ( mysql_errno( $this->dbConnectionID ) ) $this->error = mysql_error();
	 	 	 	$dauer = time() - $start;
	   	 	 }
	   	 	else
	   	 	 {
	   	 	 	$return = true;
	   	 	 	$dauer = 0;
	   	 	 }
 	 	 	
 	 	 	if ( $this->echoQuerys || $this->debugOnly )
 	 	 	 {
 	 	 	 	echo $query . ' [' . $dauer . ' s, errors: ' . $this->error . ']<br />';
 	 	 	 	flush();
 	 	 	 } 
 	 	 	$this->lastQuery = $return;
 	 	 	return $return; 	
	 	 }
	
		function sql_numrows($query_id = 0)
		{
			if(!$query_id)
			{
				$query_id = $this->lastQuery;
			}
			if($query_id)
			{
				$result = @mysql_num_rows($query_id);
				return $result;
			}
			else
			{
				return false;
			}
		}
	
		function sql_numfields($query_id = 0)
		{
			if(!$query_id)
			{
				$query_id = $this->lastQuery;
			}
			if($query_id)
			{
				$result = @mysql_num_fields($query_id);
				return $result;
			}
			else
			{
				return false;
			}
		}
	
		function sql_fieldname($offset, $query_id = 0)
		{
			if(!$query_id)
			{
				$query_id = $this->lastQuery;
			}
			if($query_id)
			{
				$result = @mysql_field_name($query_id, $offset);
				return $result;
			}
			else
			{
				return false;
			}
		}
	
		function sql_affectedrows($query_id = 0)
		{
			if(!$query_id)
			{
				$query_id = $this->lastQuery;
			}
			if($query_id)
			{
				$result = @mysql_affected_rows($query_id);
				return $result;
			}
			else
			{
				return false;
			}
		}
	
		function sql_row($query_id = 0)
		{
			if(!$query_id)
			{
				$query_id = $this->lastQuery;
			}
			if($query_id)
			{
				return @mysql_fetch_array($query_id);
				return $this->row[(int)$query_id];
			}
			else
			{
				return false;
			}
		}
	 
		function sql_getID(){
			if($this->dbConnectionID)
			{
				$result = @mysql_insert_id($this->dbConnectionID);
				return $result;
			}
			else
			{
				return false;
			}
		} 
	 
		function sql_insert ( $tabelle, $felder, $noChange = false )
		 {
		 	$query = 'INSERT INTO `' . $tabelle . '` SET ';
		 	$inhalte = array();
			if ( !$noChange ) $noChange = array();
		 	foreach ( $felder as $feldname => $feldinhalt )
		 	 {
		 	 	$content = '`' . $feldname . '` = ';
		 	 	if ( is_string ( $feldinhalt ) )
		 	 	 {
		 	 	 	$content .= '"' . ( in_array ( $feldname, $noChange ) ? $feldinhalt : $this->escape( $feldinhalt ) ) . '"';
		 	 	 }
		 	 	else
		 	 	 {
		 	 	 	$content .= $feldinhalt;
		 	 	 }
		 	 	$inhalte[] = $content;
		 	 }
		 	$query .= implode ( ', ', $inhalte );
		 	return $this->sql_query ( $query );
		 }
	
		function sql_update ( $tabelle, $felder, $where, $noChange = false, $noString = false )
		 {
		 	$query = 'UPDATE `' . $tabelle . '` SET ';
		 	$inhalte = array();
			if ( !$noChange ) $noChange = array();
			if ( !$noString ) $noString = array();
		 	foreach ( $felder as $feldname => $feldinhalt )
		 	 {
		 	 	$content = '`' . $feldname . '` = ';
		 	 	if ( ( is_object ( $feldinhalt ) || is_string ( $feldinhalt ) ) && !in_array ( $feldname, $noString ) )
		 	 	 {
		 	 	 	if ( is_object ( $feldinhalt ) )
		 	 	 	 {
		 	 	 	 	$feldinhalt = (string)$feldinhalt;
		 	 	 	 }
		 	 	 	$content .= '"' . ( in_array ( $feldname, $noChange ) ? $feldinhalt : $this->escape ( $feldinhalt ) ) . '"';
		 	 	 }
		 	 	else
		 	 	 {
		 	 	 	$content .= $feldinhalt;
		 	 	 }
		 	 	$inhalte[] = $content;
		 	 }
		 	$query .= implode ( ', ', $inhalte );
		 	
		 	if ( is_array ( $where ) ) {
		 		$whereArray = array();
		 		foreach ( $where as $field => $content ) {
		 			$whereContent =  '`' . $field . '` = ';
		 			if ( is_string ( $content ) ) {
		 				$whereContent .= '"' . $this->escape ( $content ) . '"';
		 			} elseif ( is_numeric ( $content ) ) {
		 				$whereContent .= $content;
		 			}
		 			$whereArray[] = $whereContent;
		 		}
		 		$where = implode ( ' AND ', $whereArray);
		 	}
		 	
		 	$query .= ' WHERE ' . $where;
		 	return $this->sql_query ( $query );
		 } 

		function sql_truncate ( $table ) {
			if ( is_array ( $table ) ) {
				foreach ( $table as $singleTable ) {
					$this->sql_truncate( $singleTable );
				}
			} else {
				$this->sql_query ( "TRUNCATE TABLE `" . $table . "`" );
			}
		}
	 	
	 	function sql_echo ( $option )
	 	 {
	 	 	if ( is_bool ( $option ) )
	 	 	 {
	 	 	 	$this->echoQuerys = $option;
	 	 	 }
	 	 }
	 	 
	 	function debugOnly ( $debugQueries )
	 	 {
	 	 	$this->debugOnly = $debugQueries;
	 	 }

		function get_echo ( )
		 {
		 	return $this->echoQuerys;
		 }
	 	
	 	function sql_Count ( )
	 	 {
	 	 	return $this->countQuerys;
	 	 }
		 
		function escape ( $string )
		 {
		 	if ( $this->debugOnly ) {
		 		return mysql_escape_string( $string );
		 	} else {
		 		return mysql_real_escape_string ( $string, $this->dbConnectionID );
		 	}
		 }
		
		function error() {
			return $this->error;
		}

		function __wakeup() {
			$this->connected = false;
			$this->sql_connect($this->host, $this->user, $this->pass, $this->db, $this->debug);
		}
		
		function __sleep() {
			$this->sql_close();
			return( array_keys( get_object_vars( $this ) ) );
		}
		
	 }
 }
?>